/// <reference types="node" />
/// <reference types="ioredis" />
import { Player } from 'lavalink';
import { Redis } from 'ioredis';
import QueueStore from './QueueStore';
import { EventEmitter } from 'events';
export interface NP {
    position?: number;
    track: string;
}
export default class Queue extends EventEmitter {
    readonly store: QueueStore;
    readonly guildID: string;
    readonly keys: {
        list: string;
        np: string;
    };
    constructor(store: QueueStore, guildID: string);
    readonly player: Player;
    start(): Promise<boolean>;
    add(...tracks: string[]): any;
    remove(track: string): PromiseLike<number>;
    next(): Promise<boolean>;
    stop(): Promise<void>;
    clear(): any;
    current(): Promise<NP | null>;
    tracks(): PromiseLike<string[]>;
    protected readonly _redis: Redis;
}
